local function round(num)
    return tonumber(string.format("%.0f", num))
end

local function GetVehSpeed(veh)
    return GetEntitySpeed(veh) * 3.6
end

local function oppang(ang)
    return (ang + 180) % 360
end

local function FormatSpeed(speed)
    return string.format("%03d", speed)
end

local radar = false
RegisterNetEvent("UG:OpenRadar", function()
    radar = not radar
    SendNUIMessage({
        radar = radar,
        fmodel = '',
        plate = '',
        patrolSpeed = 0,
        speedkm = 0,
        speedmph = 0,
        radartablet = radartablet
    })

    SendNUIMessage({
        type = "power",
        power = radar,
    })

    local patrolSpeed = 0;
    Citizen.CreateThread(function()
        while radar do
            Wait(1)

            if IsControlJustPressed(0, 96) then
                SendNUIMessage({
                    type = 'limit',
                    status = 'up'
                })
            end

            if IsControlJustPressed(0, 97) then
                SendNUIMessage({
                    type = 'limit',
                    status = 'down'
                })
            end

            local ped = PlayerPedId()
            local x, y, z = table.unpack(GetEntityCoords(PlayerPedId()))

            if (IsPedSittingInAnyVehicle(ped)) then
                local vehicle = GetVehiclePedIsIn(ped, false)

                if (GetPedInVehicleSeat(vehicle, -1) == ped) then
                    -- Patrol speed
                    local vehicleSpeed = round(GetVehSpeed(vehicle))

                    patrolSpeed = FormatSpeed(vehicleSpeed)

                    SendNUIMessage({
                        patrolSpeed = patrolSpeed,
                        radar = radar
                    })

                    local coordA = GetOffsetFromEntityInWorldCoords(vehicle, 0.0, 1.0, 1.0)
                    local coordB = GetOffsetFromEntityInWorldCoords(vehicle, 0.0, 105.0, 0.0)
                    local frontcar = StartShapeTestCapsule(coordA, coordB, 3.0, 10, vehicle, 7)
                    local a, b, c, d, e = GetShapeTestResult(frontcar)

                    if IsEntityAVehicle(e) then
                        local model = GetDisplayNameFromVehicleModel(GetEntityModel(e))
                        local plate = GetVehicleNumberPlateText(e)
                        local herSpeedKm = GetEntitySpeed(e) * 3.6
                        local herSpeedMph = GetEntitySpeed(e) * 2.236936

                        SendNUIMessage({
                            radar = radar,
                            model = model,
                            patrolSpeed = patrolSpeed,
                            plate = plate,
                            speedkm = herSpeedKm,
                            speedmph = herSpeedMph,
                            radartablet = radartablet
                        })
                    end

                end
            end

        end
    end)
end)
